#ifndef AFF_BOM_H
#define AFF_BOM_H

#include <algorithm>
#include <cstdlib>
#include <vector>
#include <string>
#include <map>
#include <iostream>
#ifdef HAVE_OPENSSL_PEM_H
#include <openssl/x509.h>
#include <openssl/pem.h>
#else
typedef void X509;
typedef void EVP_PKEY;
typedef void BIO;
#define BIO_free free
#endif



class outelement {
public:
    outelement(){}
    AFFILE *af;			// where output goes
    aff::seglist segs; // list of existing segments in output
};
    typedef std::vector<outelement> outlist;

int  parse_chain(const std::string &name);
int  highest_chain(aff::seglist &slist);

#ifdef USE_AFFSIGS
class aff_bom {
    X509 *cert;
    EVP_PKEY *privkey;
    char *notes;
public:
    bool opt_note;
    BIO *xml;
    aff_bom(bool flag):xml(0),cert(0),privkey(0),notes(0),opt_note(flag) { }
    ~aff_bom(){
	if(notes) free(notes);
	if(xml) BIO_free(xml);
    }
    int read_files(const char *cert_file,const char *key_file);	// returns 0 if success
    void add(const char *segname,int sigmode,const u_char *seghash,size_t seghash_len);
    void close();			// close the BoM
    int  write(AFFILE *af,aff::seglist &segments);	// write the BoM
    char *get_notes();
};
#endif

#endif
